//****************************************************************************
//	aisa22w.pas
//
//	aISA-P22
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/27
//
//****************************************************************************

unit aisa22w;

interface

uses
	Windows;

{ Errors }

const
	AISA22_SUCCESS							= 0;	 { ُȂ }
	AISA22_ERR_SYSTEM						= 1;	 { GetLastError sĂ }
	AISA22_ERR_NO_DEVICE				= 2;	 { gXbgȂ}
	AISA22_ERR_IN_USE						= 3;	 { w肳ꂽXbg͎gp }
	AISA22_ERR_INVALID_SLOT			= 4;	 { sȃXbgԍw肵 }
	AISA22_ERR_RESOURCE					= 5;	 { \[XG[ }
	AISA22_ERR_INVALID_PORT			= 6;	 { sȃ|[gv }
	AISA22_ERR_INVALID_ARGUMENT = 7;	 { sȈv }

{ Port numbers }

const
	AISA22_PORT_0	= 0;
	AISA22_PORT_1	= 1;
  AISA22_PORT_2	= 2;
  AISA22_PORT_3	= 3;


{ Miscellaneous }

const
	AISA22_MAX_SLOTS	= 16;	{ Maximum number of slots }

const
	AISA22_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA22_DLL_NAME = 'aisa22.dll';		{ DLL }

function Aisa22wDllOpen: Boolean;			{ DLL [h }
function Aisa22wDllClose: Boolean;		{ DLL A[h }


const
	AISA22_SLOT_AUTO = $ffff;

{ aISA-P22 DLL,Driver̃o[Wԍ擾 }
function Aisa22wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ CӂaISA-P22̎gp錾 }
function Aisa22wCreate(var pwLogSlot: Word): Boolean;
{ CӂaISA-P22̎gpJ }
function Aisa22wClose(wLogSlot: Word): Boolean;


{ Resource infomation structure }

const
		AISA22_MAX_MEM	=	 9;
		AISA22_MAX_IO		= 20;
		AISA22_MAX_IRQ	=	 7;
		AISA22_MAX_DMA	=	 7;

type
		TAISA22RESOURCE = record
				dwNumMemWindows:DWORD;																	{ EBhE gp }
				dwMemBase:			array [1 .. AISA22_MAX_MEM] of DWORD;		{ EChEx[XAhX@gp }
				dwMemLength:		array [1 .. AISA22_MAX_MEM] of DWORD;		{ EChE@gp }
				dwMemAttrib:		array [1 .. AISA22_MAX_MEM] of DWORD;		{ EChE@gp }
				dwNumIOPorts:		DWORD;																	{ I/O|[g }
				dwIOPortBase:		array [1 .. AISA22_MAX_IO] of DWORD;		{ I/O|[gx[XAhX }
				dwIOPortLength: array [1 .. AISA22_MAX_IO] of DWORD;		{ I/O|[g }
				dwNumIRQs:			DWORD;																	{ IRQ@gp }
				dwIRQRegisters: array [1 .. AISA22_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwIRQAttrib:		array [1 .. AISA22_MAX_IRQ] of DWORD;		{ IRQXg gp }
				dwNumDMAs:			DWORD;																	{ DMA`l gp }
				dwDMALst:				array [1 .. AISA22_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwDMAAttrib:		array [1 .. AISA22_MAX_DMA] of DWORD;		{ DMA`lXg gp }
				dwReserved1:		array [1 .. 3] of DWORD;								{ \  }
		end;

PAISA22RESOURCE = ^TAISA22RESOURCE;

{ \[X擾 }
function Aisa22wGetResource(wLogSlot: Word;  pResInfo: PAISA22RESOURCE): Boolean;

{ Cӂ̃|[gf[^ }
function Aisa22wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;

{ aISA-P22̃G[R[h }
function Aisa22wGetLastError(wLogSlot: Word): DWord;

implementation

type
	TAisa22GetVersion = function(var pdwDllVer: DWORD; var pdwDrvVer: DWORD): BOOL; stdcall;
	TAisa22Create = function(var pwLogSlot: Word): BOOL; stdcall;
	TAisa22Close = function(wLogSlot:	WORD): BOOL; stdcall;
	TAisa22GetResource = function(wLogSlot: WORD; res: PAISA22RESOURCE):	BOOL; stdcall;
	TAisa22InPort = function(wLogSlot: WORD; dwLogPort: DWORD; var lpbInValue: BYTE): BOOL; stdcall;
	TAisa22GetLastError = function(wLogSlot: WORD): DWORD; stdcall;

function Aisa22wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

 { DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa22GetVersion: TAisa22GetVersion;
	pAisa22Create: TAisa22Create;
	pAisa22Close: TAisa22Close;
	pAisa22GetResource: TAisa22GetResource;
	pAisa22InPort: TAisa22InPort;
	pAisa22GetLastError: TAisa22GetLastError;


//****************************************************************************
// @\			aisa22.dll[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa22wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA22_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa22wGetDllExportFunc = False then
  begin
       Aisa22wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		   Exit;
  end;

	Result := True;
end;

//****************************************************************************
// @\			aisa22.dllA[h
// 			Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa22wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;

//****************************************************************************
// @\			aISA-P22 DLL,Driver̃o[Wԍ擾
// 			pdwDllVer --- DLLo[Wԍi[
//					pdwDrvVer --- Drivero[Wԍi[
// ߂l 	True  				--- 
//		  		False 				--- s
//****************************************************************************
function Aisa22wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa22GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// @\			aISA-P22̔Cӂ̃foCX̎gp錾
// 			pwLogSlot	 --- gpfoCXi[AhX
// ߂l 	True  		 --- 
//		  		False 		 --- s
//****************************************************************************
function Aisa22wCreate(var pwLogSlot: Word): Boolean;
begin
  Result := False;

  if hDLL = 0 then Exit;

	Result := pAisa22Create(pwLogSlot);
end;

//****************************************************************************
// @\			aISA-P22̔Cӂ̃foCX̎gpJ
// 			wLogSlot --- gpfoCX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa22wClose(wLogSlot: Word): Boolean;
begin
  Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa22Close(wLogSlot);
end;

//****************************************************************************
// @\		wfoCX̃\[X擾
// 			wLogSlot --- ׂfoCX
//					pResInfo --- \[Xi[\̂̃AhX
// ߂l 	True  	 --- 
//		  		False 	 --- s
//****************************************************************************
function Aisa22wGetResource(wLogSlot: Word;  pResInfo: PAISA22RESOURCE): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa22GetResource(wLogSlot, pResInfo);
end;

//****************************************************************************
// @\			Cӂ̃|[gf[^
// 			wLogSlot	--- ͂foCX
//					dwPort		--- ͂|[g
//					pbInValue --- ̓f[^i[
// ߂l 	True  		--- 
//		  		False 		--- s
//****************************************************************************
function Aisa22wInPort(wLogSlot: Word; dwPort: DWord; var pbInValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa22InPort(wLogSlot, dwPort, pbInValue);
end;

//****************************************************************************
// @\			aISA-P22̃G[R[h
// 			wLogSlot --- G[foCX
// ߂l 				 	 --- G[R[h
//****************************************************************************
function Aisa22wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA22_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa22GetLastError(wLogSlot);
end;

//****************************************************************************
// 	  	DLLGNX|[g֐AhX̎擾
// 	  	Ȃ
// ߂l 	True  --- 
//		  		False --- s
//****************************************************************************
function Aisa22wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa22GetVersion ̃AhX擾
	pAisa22GetVersion := GetProcAddress(hDLL, 'Aisa22GetVersion');
	if @pAisa22GetVersion = nil then Exit;

	// Aisa22Create ̃AhX擾
	pAisa22Create := GetProcAddress(hDLL, 'Aisa22Create');
	if @pAisa22Create = nil then Exit;

	// Aisa22Close ̃AhX擾
	pAisa22Close := GetProcAddress(hDLL, 'Aisa22Close');
	if @pAisa22Close = nil then Exit;

	// Aisa22GetResource ̃AhX擾
	pAisa22GetResource := GetProcAddress(hDLL, 'Aisa22GetResource');
	if @pAisa22GetResource = nil then Exit;

	// Aisa22InPort ̃AhX擾
	pAisa22InPort := GetProcAddress(hDLL, 'Aisa22InPort');
	if @pAisa22InPort = nil then Exit;

	// Aisa22GetLastError ̃AhX擾
	pAisa22GetLastError := GetProcAddress(hDLL, 'Aisa22GetLastError');
	if @pAisa22GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

