Attribute VB_Name = "Sample"
'*****************************************************************************
'* aisa22s.bas
'*
'* aISA-P22
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/06/01
'*
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
'*
'*****************************************************************************
Option Explicit

Private Const szName = "aISA-P22"
Private Declare Function GetLastError Lib "kernel32" () As Long

Sub Main()

    Dim strbuf As String
    Dim dwDllVer As Long                ' DLL̃o[W
    Dim dwDrvVer As Long                ' Driver̃o[W
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim InValue As Byte                 ' ̓f[^
    Dim ri As AISA22RESOURCE            ' \[X

'---------------------------------------------------------------------------
    ' aisa22.dll ̎gp錾
    If Aisa22wDllOpen() = False Then
        ErrorMessage (AISA22_SLOT_AUTO)
        Exit Sub                ' aisa22.dll ̃[hɎs܂B
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Aisa22wGetVersion(dwDllVer, dwDrvVer) = False Then ' aISA-P22DLL,Driver̃o[Wԍ擾
        ErrorMessage (AISA22_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-P22̎gp錾
    wLogSlot = AISA22_SLOT_AUTO     ' gp̃foCXT܂B
    bResult = Aisa22wCreate(wLogSlot)

    If bResult = False Then         ' foCX܂B
        ErrorMessage (AISA22_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "aISA-P22 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Aisa22wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + szName + Chr(10) + _
             "NumPorts: " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' Port 0 f[^ǂݍ
    InValue = &H0

    If Aisa22wInPort(wLogSlot, AISA22_PORT_0, InValue) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Port 0 f[^" + Chr(10) + _
             "Port 0 In Data: &H" + Hex(InValue)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-P22̎gpJ
    If Aisa22wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-P22 Closed")

'---------------------------------------------------------------------------
    ' aisa22.dll̎gpJ
    If Aisa22wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub        ' aisa22.dll ̃A[hɎs܂B
    End If

End Sub

'---------------------------------------------------------------------------
' ʂ\
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub

'---------------------------------------------------------------------------
' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Long
    Dim szbuf As String

    dwRes = Aisa22wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA22_ERR_SYSTEM
        szbuf = "System error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(GetLastError())

    Case AISA22_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aISA-P22 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
