Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa22w.bas
'*
'* aISA-P22
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/05/08
'*
'*****************************************************************************
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA22_DLL_NAME = "aisa22.dll"  ' DLLt@C
Global Const AISA22_ERR_WRAPDLL = -1        ' bp[֐G[

Dim hDLL As Long                'DLLւ̃nh

'*****************************************************************************
'* @\     aisa22.dll[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa22wDllOpen() As Boolean

    Aisa22wDllOpen = False
    
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(AISA22_DLL_NAME)
    
    If hDLL = 0 Then Exit Function
    
    If Aisa22wGetDllExportFunc() = False Then
        Aisa22wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    
    Aisa22wDllOpen = True

End Function

'*****************************************************************************
'* @\     aisa22.dllA[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa22wDllClose() As Boolean
    
    If hDLL = 0 Then
        Aisa22wDllClose = True
        Exit Function
    End If
    
    If FreeLibrary(hDLL) <> 0 Then
        hDLL = 0
        Aisa22wDllClose = True
        Exit Function
    End If
    
    Aisa22wDllClose = False

End Function

'*****************************************************************************
'* @\     aISA-P22 DLL,Driver̃o[Wԍ擾
'*      pdwDllVer --- DLLo[Wԍi[
'*          pdwDrvVer --- Drivero[Wԍi[
'* ߂l   True          --- 
'*          False         --- s
'*****************************************************************************
Function Aisa22wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean
    
    If hDLL = 0 Then
        Aisa22wGetVersion = 0
        Exit Function
    End If
    
    If Aisa22GetVersion(pdwDllVer, pdwDrvVer) <> 0 Then
        Aisa22wGetVersion = True
    Else
        Aisa22wGetVersion = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-P22̔Cӂ̃foCX̎gp錾
'*      pwLogSlot --- gpfoCXi[AhX
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa22wCreate(pwLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa22wCreate = False
        Exit Function
    End If
    
    If Aisa22Create(pwLogSlot) <> 0 Then
        Aisa22wCreate = True
    Else
        Aisa22wCreate = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-P22̔Cӂ̃foCX̎gpJ
'*      wLogSlot --- gpfoCX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa22wClose(wLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa22wClose = False
        Exit Function
    End If
    
    If Aisa22Close(wLogSlot) <> 0 Then
        Aisa22wClose = True
    Else
        Aisa22wClose = False
    End If

End Function

'*****************************************************************************
'* @\     wfoCX̃\[X擾
'*      wLogSlot --- ׂfoCX
'*          pResInfo --- \[Xi[\̂̃AhX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa22wGetResource(wLogSlot As Integer, pResInfo As AISA22RESOURCE) As Boolean
    
    If hDLL = 0 Then
        Aisa22wGetResource = False
        Exit Function
    End If
    
    If Aisa22GetResource(wLogSlot, pResInfo) <> 0 Then
        Aisa22wGetResource = True
    Else
        Aisa22wGetResource = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gf[^
'*      wLogSlot  --- ͂foCX
'*          dwPort    --- ͂|[g
'*          pbInValue --- ̓f[^i[
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa22wInPort(wLogSlot As Integer, dwPort As Long, pbInValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa22wInPort = False
        Exit Function
    End If
    
    If Aisa22InPort(wLogSlot, dwPort, pbInValue) <> 0 Then
        Aisa22wInPort = True
    Else
        Aisa22wInPort = False
    End If

End Function

'*****************************************************************************
'* @\      aISA-P22̃G[R[h𓾂
'*       wLogSlot --- G[foCX
'* ߂l             --- G[R[h
'*****************************************************************************
Function Aisa22wGetLastError(wLogSlot As Integer) As Long
    
    If hDLL = 0 Then
        Aisa22wGetLastError = AISA22_ERR_WRAPDLL
        Exit Function
    End If
    
    Aisa22wGetLastError = Aisa22GetLastError(wLogSlot)

End Function

'*****************************************************************************
'* @\     DLLGNX|[g֐L̊mF
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Private Function Aisa22wGetDllExportFunc() As Boolean
    
    Dim pFunc As Long
    
    Aisa22wGetDllExportFunc = False
    
    ' Aisa22GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa22GetVersion")
    If pFunc = 0 Then Exit Function
          
    ' Aisa22Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa22Create")
    If pFunc = 0 Then Exit Function
          
    ' Aisa22Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa22Close")
    If pFunc = 0 Then Exit Function

    ' Aisa22GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa22GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa22InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa22InPort")
    If pFunc = 0 Then Exit Function

    ' Aisa22GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa22GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa22wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
